3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] [--cached]
9 or: $dashless [--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
10 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
11 or: $dashless [--quiet] init [--] [<path>...]
12 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
13 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
14 or: $dashless [--quiet] set-branch (--default|--branch <branch>) [--] <path>
15 or: $dashless [--quiet] set-url [--] <path> <newurl>
16 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
17 or: $dashless [--quiet] foreach [--recursive] <command>
18 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
19 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
25 wt_prefix=$(git rev-parse --show-prefix)
28 # Tell the rest of git that any URLs we get don't come
29 # directly from the user, so it can apply policy as appropriate.
30 GIT_PROTOCOL_FROM_USER=0
31 export GIT_PROTOCOL_FROM_USER
53 if test "$1" = "#unmatched"
60 # Print a submodule configuration setting
66 # Checks in the usual git-config places first (for overrides),
67 # otherwise it falls back on .gitmodules. This allows you to
68 # distribute project-wide defaults in .gitmodules, while still
69 # customizing individual repositories if necessary. If the option is
70 # not in .gitmodules either, print a default value.
72 get_submodule_config () {
76 value=$(git config submodule."$name"."$option")
79 value=$(git submodule--helper config submodule."$name"."$option")
81 printf '%s' "${value:-$default}"
86 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
89 # Given a full hex object ID, is this the zero OID?
91 echo "$1" | sane_egrep '^0+$' >/dev/null 2>&1
94 # Sanitize the local git environment for use within a submodule. We
95 # can't simply use clear_local_git_env since we want to preserve some
96 # of the settings from GIT_CONFIG_PARAMETERS.
97 sanitize_submodule_env()
99 save_config=$GIT_CONFIG_PARAMETERS
101 GIT_CONFIG_PARAMETERS=$save_config
102 export GIT_CONFIG_PARAMETERS
106 # Add a new submodule to the working tree, .gitmodules and the index
110 # optional branch is stored in global branch variable
114 # parse $args after "submodule ... add".
120 case "$2" in '') usage ;; esac
134 case "$2" in '') usage ;; esac
139 reference_path="${1#--reference=}"
145 case "$2" in '') usage ;; esac
150 case "$2" in '') usage ;; esac
171 if ! git submodule--helper config --check-writeable >/dev/null 2>&1
173 die "$(eval_gettext "please make sure that the .gitmodules file is in the working tree")"
176 if test -n "$reference_path"
178 is_absolute_path "$reference_path" ||
179 reference_path="$wt_prefix$reference_path"
181 reference="--reference=$reference_path"
187 if test -z "$sm_path"; then
188 sm_path=$(printf '%s\n' "$repo" |
189 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
192 if test -z "$repo" || test -z "$sm_path"; then
196 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
198 # assure repo is absolute or relative to parent
201 test -z "$wt_prefix" ||
202 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
204 # dereference source url relative to parent's url
205 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
212 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
217 # multiple //; leading ./; /./; /../; trailing /
218 sm_path=$(printf '%s/\n' "$sm_path" |
230 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
231 die "$(eval_gettext "'\$sm_path' already exists in the index")"
233 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
234 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
237 if test -d "$sm_path" &&
238 test -z $(git -C "$sm_path" rev-parse --show-cdup 2>/dev/null)
240 git -C "$sm_path" rev-parse --verify -q HEAD >/dev/null ||
241 die "$(eval_gettext "'\$sm_path' does not have a commit checked out")"
244 if test -z "$force" &&
245 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
247 eval_gettextln "The following path is ignored by one of your .gitignore files:
249 Use -f if you really want to add it." >&2
253 if test -n "$custom_name"
255 sm_name="$custom_name"
260 if ! git submodule--helper check-name "$sm_name"
262 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
265 # perhaps the path exists and is already a git repo, else clone it
266 if test -e "$sm_path"
268 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
270 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
272 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
276 if test -d ".git/modules/$sm_name"
280 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
281 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
282 die "$(eval_gettextln "\
283 If you want to reuse this local git directory instead of cloning again from
285 use the '--force' option. If the local git directory is not the correct repo
286 or you are unsure what this means choose another name with the '--name' option.")"
288 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
291 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
293 sanitize_submodule_env
295 # ash fails to wordsplit ${branch:+-b "$branch"...}
297 '') git checkout -f -q ;;
298 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
300 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
302 git config submodule."$sm_name".url "$realrepo"
304 git add --no-warn-embedded-repo $force "$sm_path" ||
305 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
307 git submodule--helper config submodule."$sm_name".path "$sm_path" &&
308 git submodule--helper config submodule."$sm_name".url "$repo" &&
311 git submodule--helper config submodule."$sm_name".branch "$branch"
313 git add --force .gitmodules ||
314 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
316 # NEEDSWORK: In a multi-working-tree world, this needs to be
317 # set in the per-worktree config.
318 if git config --get submodule.active >/dev/null
320 # If the submodule being adding isn't already covered by the
321 # current configured pathspec, set the submodule's active flag
322 if ! git submodule--helper is-active "$sm_path"
324 git config submodule."$sm_name".active "true"
327 git config submodule."$sm_name".active "true"
332 # Execute an arbitrary command sequence in each checked out
335 # $@ = command to execute
339 # parse $args after "submodule ... foreach".
359 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
363 # Register submodules in .git/config
365 # $@ = requested paths (default to all)
369 # parse $args after "submodule ... init".
390 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} -- "$@"
394 # Unregister submodules from .git/config and remove their work tree
398 # parse $args after "submodule ... deinit".
426 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} -- "$@"
429 is_tip_reachable () (
430 sanitize_submodule_env &&
432 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
436 fetch_in_submodule () (
437 sanitize_submodule_env &&
444 git fetch $(get_default_remote) "$@" ;;
449 # Update each submodule path to correct revision, using clone and checkout as needed
451 # $@ = requested paths (default to all)
455 # parse $args after "submodule ... update".
488 case "$2" in '') usage ;; esac
489 reference="--reference=$2"
508 recommend_shallow="--recommend-shallow"
510 --no-recommend-shallow)
511 recommend_shallow="--no-recommend-shallow"
514 case "$2" in '') usage ;; esac
522 case "$2" in '') usage ;; esac
545 cmd_init "--" "$@" || return
549 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
550 ${progress:+"--progress"} \
551 ${wt_prefix:+--prefix "$wt_prefix"} \
552 ${prefix:+--recursive-prefix "$prefix"} \
553 ${update:+--update "$update"} \
554 ${reference:+"$reference"} \
555 ${dissociate:+"--dissociate"} \
556 ${depth:+--depth "$depth"} \
557 ${require_init:+--require-init} \
561 "$@" || echo "#unmatched" $?
564 while read -r quickabort sha1 just_cloned sm_path
566 die_if_unmatched "$quickabort" "$sha1"
568 git submodule--helper ensure-core-worktree "$sm_path" || exit 1
570 update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
572 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
574 if test $just_cloned -eq 1
578 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
579 git rev-parse --verify HEAD) ||
580 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
585 branch=$(git submodule--helper remote-branch "$sm_path")
586 if test -z "$nofetch"
588 # Fetch remote before determining tracking $sha1
589 fetch_in_submodule "$sm_path" $depth ||
590 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
592 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
593 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
594 git rev-parse --verify "${remote_name}/${branch}") ||
595 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
598 if test "$subsha1" != "$sha1" || test -n "$force"
601 # If we don't already have a -f flag and the submodule has never been checked out
602 if test -z "$subsha1" && test -z "$force"
607 if test -z "$nofetch"
609 # Run fetch only if $sha1 isn't present or it
610 # is not reachable from a ref.
611 is_tip_reachable "$sm_path" "$sha1" ||
612 fetch_in_submodule "$sm_path" $depth ||
613 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'; trying to directly fetch \$sha1:")"
615 # Now we tried the usual fetch, but $sha1 may
616 # not be reachable from any of the refs
617 is_tip_reachable "$sm_path" "$sha1" ||
618 fetch_in_submodule "$sm_path" $depth "$sha1" ||
619 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
623 case "$update_module" in
625 command="git checkout $subforce -q"
626 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
627 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
631 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
632 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
633 must_die_on_failure=yes
637 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
638 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
639 must_die_on_failure=yes
642 command="${update_module#!}"
643 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
644 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
645 must_die_on_failure=yes
648 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
651 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
654 elif test -n "$must_die_on_failure"
656 die_with_status 2 "$die_msg"
658 err="${err};$die_msg"
663 if test -n "$recursive"
666 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
668 sanitize_submodule_env
675 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
678 err="${err};$die_msg"
681 die_with_status $res "$die_msg"
705 # Configures a submodule's default branch
707 # $@ = requested path
717 # we don't do anything with this but we need to accept it
723 case "$2" in '') usage ;; esac
746 # we can't use `git submodule--helper name` here because internally, it
747 # hashes the path so a trailing slash could lead to an unintentional no match
748 name="$(git submodule--helper list "$1" | cut -f2)"
754 test -n "$branch"; has_branch=$?
755 test "$unset_branch" = true; has_unset_branch=$?
757 if test $((!$has_branch != !$has_unset_branch)) -eq 0
762 if test $has_branch -eq 0
764 git submodule--helper config submodule."$name".branch "$branch"
766 git submodule--helper config --unset submodule."$name".branch
771 # Configures a submodule's remote url
773 # $@ = requested path, requested url
801 # we can't use `git submodule--helper name` here because internally, it
802 # hashes the path so a trailing slash could lead to an unintentional no match
803 name="$(git submodule--helper list "$1" | cut -f2)"
815 git submodule--helper config submodule."$name".url "$url"
816 git submodule--helper sync ${GIT_QUIET:+--quiet} "$name"
820 # Show commit summary for submodules in index or working tree
822 # If '--cached' is given, show summary between index and given commit,
823 # or between working tree and given commit
825 # $@ = [commit (default 'HEAD'),] requested paths (default all)
832 # parse $args after "submodule ... summary".
847 isnumber "$summary_limit" || usage
851 summary_limit="${1#--summary-limit=}"
852 isnumber "$summary_limit" || usage
868 test $summary_limit = 0 && return
870 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
874 elif test -z "$1" || test "$1" = "HEAD"
876 # before the first commit: compare with an empty tree
877 head=$(git hash-object -w -t tree --stdin </dev/null)
878 test -z "$1" || shift
886 die "$(gettext "The --cached option cannot be used with the --files option")"
892 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
893 # Get modified modules cared by user
894 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
895 sane_egrep '^:([0-7]* )?160000' |
896 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
898 # Always show modules deleted or type-changed (blob<->module)
899 if test "$status" = D || test "$status" = T
901 printf '%s\n' "$sm_path"
904 # Respect the ignore setting for --for-status.
905 if test -n "$for_status"
907 name=$(git submodule--helper name "$sm_path")
908 ignore_config=$(get_submodule_config "$name" ignore none)
909 test $status != A && test $ignore_config = all && continue
911 # Also show added or modified modules which are checked out
912 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
913 printf '%s\n' "$sm_path"
917 test -z "$modules" && return
919 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
920 sane_egrep '^:([0-7]* )?160000' |
922 while read -r mod_src mod_dst sha1_src sha1_dst status name
924 if test -z "$cached" &&
925 is_zero_oid $sha1_dst
929 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
931 100644 | 100755 | 120000)
932 sha1_dst=$(git hash-object $name)
938 eval_gettextln "unexpected mode \$mod_dst" >&2
945 test $mod_src = 160000 &&
946 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
949 test $mod_dst = 160000 &&
950 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
953 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
956 case "$missing_src,$missing_dst" in
958 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
961 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
964 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
969 if test $mod_src = 160000 && test $mod_dst = 160000
971 range="$sha1_src...$sha1_dst"
972 elif test $mod_src = 160000
978 GIT_DIR="$name/.git" \
979 git rev-list --first-parent $range -- | wc -l
981 total_commits=" ($(($total_commits + 0)))"
985 sha1_abbr_src=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_src 2>/dev/null ||
986 echo $sha1_src | cut -c1-7)
987 sha1_abbr_dst=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_dst 2>/dev/null ||
988 echo $sha1_dst | cut -c1-7)
992 blob="$(gettext "blob")"
993 submodule="$(gettext "submodule")"
994 if test $mod_dst = 160000
996 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
998 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1001 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1003 if test -n "$errmsg"
1005 # Don't give error msg for modification whose dst is not submodule
1006 # i.e. deleted or changed to blob
1007 test $mod_dst = 160000 && echo "$errmsg"
1009 if test $mod_src = 160000 && test $mod_dst = 160000
1012 test $summary_limit -gt 0 && limit="-$summary_limit"
1013 GIT_DIR="$name/.git" \
1014 git log $limit --pretty='format: %m %s' \
1015 --first-parent $sha1_src...$sha1_dst
1016 elif test $mod_dst = 160000
1018 GIT_DIR="$name/.git" \
1019 git log --pretty='format: > %s' -1 $sha1_dst
1021 GIT_DIR="$name/.git" \
1022 git log --pretty='format: < %s' -1 $sha1_src
1030 # List all submodules, prefixed with:
1031 # - submodule not initialized
1032 # + different revision checked out
1034 # If --cached was specified the revision in the index will be printed
1035 # instead of the currently checked out revision.
1037 # $@ = requested paths (default to all)
1041 # parse $args after "submodule ... status".
1068 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} -- "$@"
1071 # Sync remote urls for submodules
1072 # This makes the value for remote.$remote.url match the value
1073 # specified in .gitmodules.
1101 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
1106 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1109 # This loop parses the command line arguments to find the
1110 # subcommand name to dispatch. Parsing of the subcommand specific
1111 # options are primarily done by the subcommand implementations.
1112 # Subcommand specific options such as --branch and --cached are
1113 # parsed here as well, for backward compatibility.
1115 while test $# != 0 && test -z "$command"
1118 add | foreach | init | deinit | update | set-branch | set-url | status | summary | sync | absorbgitdirs)
1148 # No command word defaults to "status"
1149 if test -z "$command"
1159 # "-b branch" is accepted only by "add" and "set-branch"
1160 if test -n "$branch" && (test "$command" != add || test "$command" != set-branch)
1165 # "--cached" is accepted only by "status" and "summary"
1166 if test -n "$cached" && test "$command" != status && test "$command" != summary
1171 "cmd_$(echo $command | sed -e s/-/_/g)" "$@"